#ifndef _MMOBJECT_H_INCLUDED_
#define _MMOBJECT_H_INCLUDED_

#include <windows.h>
#include <string>

#define SAFE_DELETE(p)       { if(p) { delete (p);     (p)=NULL; } }
#define SAFE_DELETE_ARRAY(p) { if(p) { delete[] (p);   (p)=NULL; } }
#define SAFE_RELEASE(p)      { if(p) { (p)->Release(); (p)=NULL; } }

class CMMObject
{
public:
	CMMObject() : refcount( 1 ), tag( 0 ), name( L"" ) {};
	CMMObject( LPWSTR NAME, int TAG ) : refcount( 1 ), tag( TAG ), name( NAME ) {};
	virtual ~CMMObject() { CleanUp (); };
	virtual void CleanUp() {};
	virtual void AddRef();
	virtual void Release();
	virtual int GetRefCount();
	virtual void SetName( LPWSTR NAME );
	virtual std::wstring GetName();
	virtual void SetTag( int TAG );
	virtual int GetTag();

protected:
	int refcount;
	int tag;
	std::wstring name;
};

#endif // #ifndef _MMOBJECT_H_INCLUDED_